%define section free

# If you do not want to build samples in demo subpackage because of their 
# runtime deps, give rpmbuild option '--without demo'
%define with_demo %{!?_without_demo:1}%{?_without_demo:0}

Name:		xdoclet
Version:	1.2.3
Release:	1jpp
Epoch:		0
Summary:	XDoclet Attribute Orientated Programming Framework
License:	XDoclet Open Source Licence
Group:		Development/Framework
Vendor:		JPackage Project
Distribution:	JPackage
URL:		http://xdoclet.sourceforge.net
Source0:	%{name}-src-%{version}.tgz
Source1:	%{name}-modules-objectweb-4.3.tgz
Patch0:		xdoclet-build_xml.patch
Patch1:		xdoclet-XDocletModulesEjbMessages.patch
Patch2:		xdoclet-ant.not-required.patch
Patch3:		xdoclet-WebLogicSubTask.patch

BuildArch:	noarch
BuildRoot: 	%{_tmppath}/%{name}-root
BuildRequires:  java-devel
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  maven
BuildRequires:  junit
BuildRequires:  javacc
BuildRequires:  jrefactory
BuildRequires:  maven
BuildRequires:  bsf 
BuildRequires:  jakarta-commons-collections 
BuildRequires:  jakarta-commons-lang 
BuildRequires:  jakarta-commons-logging 
BuildRequires:  jakarta-commons-net 
BuildRequires:  log4j
BuildRequires:  mockobjects 
BuildRequires:  struts 
BuildRequires:  velocity 
BuildRequires:  xalan-j2
BuildRequires:  xml-commons-apis 
BuildRequires:  xjavadoc >= 0:1.1
#
Requires:  bsf
Requires:  jakarta-commons-collections
Requires:  jakarta-commons-logging
Requires:  log4j
Requires:  mockobjects
Requires:  velocity
Requires:  xalan-j2
Requires:  xml-commons-apis
Requires:  xjavadoc = 0:1.1

%description
This package contains the XDoclet Attribute Orientated Programming Framework

%if %{with_demo}
%package demo
Summary:	XDoclet Sample Projects
Group:		Development/Framework
BuildRequires:  servletapi4
BuildRequires:  struts
BuildRequires:  velocity
BuildRequires:  webwork >= 0:2.1
BuildRequires:  xwork
BuildRequires:  ejb
BuildRequires:  jsf
BuildRequires:  jms
BuildRequires:  mx4j
Requires:  %{name} = %{version}-%{release}
Requires:  ejb
Requires:  jsf
Requires:  jms
Requires:  webwork
Requires:  xwork
Requires:  mx4j
Requires:  struts
Requires:  servletapi4

%description demo
This package contains sample XDoclet projects.
%endif

%package javadoc
Summary:	XDoclet Javadoc
Group:		Development/Documentation

%description javadoc
This package contains XDoclet javadoc

%package manual
Summary:	XDoclet Sample Manuals and Documentation
Group:		Development/Documentation

%description manual
This package contains XDoclet documentation.

%prep
%setup -q
#find . -name "*.jar" -exec rm {} \;
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done

# Replace JOnAS specific tasks with code blessed by ObjectWeb
pushd modules
mv objectweb objectweb.orig
tar xzf %{SOURCE1}
popd

for j in xjavadoc-1.1 jrefactory javacc junit bsf commons-collections commons-logging log4j velocity xalan-j2 xjavadoc xml-commons-apis mockobjects-core; do
	ln -s $(build-classpath $j) lib/$j.jar
done

%if %{with_demo}
for j in servletapi4 struts velocity webwork-migration xwork ejb jsf-api jms; do
	ln -s $(build-classpath $j) samples/lib/$j.jar
done
for j in mx4j/mx4j-jmx mx4j/mx4j-tools; do
        i=$(build-classpath $j)
	ln -s $i samples/lib/$(basename $i)
done
%endif

%patch0 -b .sav
%patch1 -b .sav
%patch2
%patch3 -b .sav

%build
export MAVEN_HOME=/usr/share/maven-1.0
export MAVEN_LOCAL_HOME=$(pwd)/.maven
mkdir -p .maven/plugins
mkdir -p .maven/repository/JPP/jars
build-jar-repository .maven/repository/JPP/jars commons-lang commons-net
mkdir -p .maven/repository/maven/jars
build-jar-repository .maven/repository/maven/jars maven-jelly-tags
echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> project.properties
echo maven.home.local=$(pwd)/.maven >> project.properties
export CLASSPATH=$(build-classpath ant)
ant -Dbuild.sysclasspath=first
%if %{with_demo}
ant samples
%endif

%install
mkdir -p $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 target/lib/xdoclet*.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 target/lib/maven-xdoclet*.jar $RPM_BUILD_ROOT%{_javadir}/%{name}
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

%if %{with_demo}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
cp -pr samples/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
%endif

mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
rm -rf target/docs/api

mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%files
%defattr(-, root, root, -)
%{_javadir}/%{name}
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt

%if %{with_demo}
%files demo
%defattr(-, root, root, -)
%{_datadir}/%{name}-%{version}
%endif

%files javadoc
%defattr(-, root, root, -)
%doc %{_javadocdir}/%{name}-%{version}

%files manual
%defattr(-, root, root, -)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Tue Dec 20 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.3-1jpp
- Upgrade to 1.2.3
- Build docs with maven

* Fri Sep 23 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.2-3jpp
- Adapt to build samples with webwork-2.1.7

* Fri Mar 04 2005 Fernando Nasser <fnasser@redhat.com> - 0:1.2.2-2jpp
- Add patch to prevent attempt to load DTD from the net, when it comes with
  the source and is locally available
- Replace JOnAS specific tasks with code blessed by ObjectWeb
- Do not save copies of the java files when patching.

* Tue Feb 15 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.2.2-1jpp
- Upgrade to 1.2.2
- Add jsf requirement for demo
- Drop jndi requirement for demo
- Drop servletapi and mx4j requirement for main package
- Buildrequire maven and use it to build docs

* Thu Aug 26 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.2.1-2jpp
- Build with ant-1.6.2

* Fri Jul 02 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.2.1-1jpp
- Upgrade to 1.2.1
- Relax build-time dependencies
- Relax dependency versions
- Make subpackage xdoclet-demo optional

* Fri Mar 05 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.2-1jpp
- First JPackage release.

